#include <stdio.h>

char *basic_pinname ( cellname, pinname )
  char *cellname,
       *pinname;
{
  static char *N0 = "n[0:0]";
  static char *N1 = "n[1:1]";
  static char *N2 = "n[2:2]";
  static char *N3 = "n[3:3]";
  static char *N4 = "n[4:4]";
  static char *N5 = "n[5:5]";
  static char *N6 = "n[6:6]";
  static char *N7 = "n[7:7]";
  static char *S0 = "s[0:0]";
  static char *S1 = "s[1:1]";
  static char *S2 = "s[2:2]";
  static char *S3 = "s[3:3]";
  static char *VSS = "VSS";

  if ( !strcmp(cellname,"INV") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   }
  if ( !strcmp(cellname,"NAND2") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   } 
  if ( !strcmp(cellname,"NOR2") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   } 
  if ( !strcmp(cellname,"XOR2") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   } 
  if ( !strcmp(cellname,"XNOR2") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   } 
  if ( !strcmp(cellname,"AND2") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   }
  if ( !strcmp(cellname,"OR2") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   } 
  if ( !strcmp(cellname,"MUX") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"E3") ) return(N2);
     if ( !strcmp(pinname,"A1") ) return(S0);
     return (VSS);
   } 
  if ( !strcmp(cellname,"FA") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"E3") ) return(N2);
     if ( !strcmp(pinname,"A1") ) return(S0);
     if ( !strcmp(pinname,"A2") ) return(S1);
     return (VSS);
   } 
  if ( !strcmp(cellname,"HA") )
   {
     if ( !strcmp(pinname,"E1") ) return(N0);
     if ( !strcmp(pinname,"E2") ) return(N1);
     if ( !strcmp(pinname,"A1") ) return(S0);
     if ( !strcmp(pinname,"A2") ) return(S1);
     return (VSS);
   } 
  if ( !strcmp(cellname,"PRESET_0") )
   {
     if ( !strcmp(pinname,"A1") ) return(S0);
   }
  if ( !strcmp(cellname,"PRESET_1") )
   {
     if ( !strcmp(pinname,"A1") ) return(S0);
   }
  fprintf ( stderr , "unknown basic-cell %s\n" , cellname );
  return (VSS);
}

