
#include <stdio.h>


void my_exit ( name )
  char *name;
{
  fprintf ( stderr , "Basiszelle %s noch nicht implementiert\n" , name );
  exit (-1);
}


void basic_cell ( cellname, n, e, s , w )
  char *cellname;
  char n[], e[], s[], w[];
{
  if ( !strcmp(cellname,"INV") )
   {
     s[0] = ( n[0] == '0' ) ? '1' : '0';
     return;
   }
  if ( !strcmp(cellname,"NAND2") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"NOR2") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' ) ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"XOR2") )
   {
     s[0] = ( n[0] == n[1] ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"XNOR2") )
   {
     s[0] = ( n[0] == n[1] ) ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"AND2") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' ) ? '1' : '0';
     return;
   }
  if ( !strcmp(cellname,"OR2") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"MUX") )
   {
     s[0] = ( n[2] == '1' ) ? n[0] : n[1];
     return;
   } 
  if ( !strcmp(cellname,"FA") )
   {
     s[0] = ( n[1] == '1' && n[2] == '1' ||
              n[0] == '1' && n[2] == '1' ||
              n[0] == '1' && n[1] == '1') ? '1' : '0';
     s[1] = ( n[0] == '0' && n[1] == '0' && n[2] == '1' ||
              n[0] == '0' && n[1] == '1' && n[2] == '0' ||
              n[0] == '1' && n[1] == '0' && n[2] == '0' ||
              n[0] == '1' && n[1] == '1' && n[2] == '1') ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"HA") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' ) ? '1' : '0';
     s[1] = ( n[0] != n[1]) ? '1' : '0';

     return;
   } 
  if ( !strcmp(cellname,"PRESET_0") )
   {
     s[0] = '0';
     return;
   } 
  if ( !strcmp(cellname,"PRESET_1") )
   {
     s[0] = '1';
     return;
   } 
  
 
  my_exit ( cellname );
}

