
#include <stdio.h>


void my_exit ( name )
  char *name;
{
  fprintf ( stderr , "Basiszelle %s noch nicht implementiert\n" , name );
  exit (-1);
}


void basic_cell ( cellname, n, e, s , w )
  char *cellname;
  char n[], e[], s[], w[];
{
  if ( !strcmp(cellname,"iinv1a") )
   {
     s[0] = ( n[0] == '0' ) ? '1' : '0';
     return;
   }
  if ( !strcmp(cellname,"icin1b") )
   {
     my_exit ( "icin1b" );
   } 
  if ( !strcmp(cellname,"ibuf1a") )
   {
     s[0] = n[0];
     return;
   } 
  if ( !strcmp(cellname,"ibuf4a") )
   {
     s[0] = n[0];
     return;
   } 
  if ( !strcmp(cellname,"inan2a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"inan3a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' && n[2] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"inan4a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' && n[2] == '1' && n[3] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"inan5a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' && n[2] == '1' && n[3] == '1' && n[4] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"inan6a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' && n[2] == '1' && n[3] == '1' && n[4] == '1' && n[5] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"inan7a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' && n[2] == '1' && n[3] == '1' && n[4] == '1' && n[5] == '1' && n[6] == '1' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"inor2a") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' ) ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"inor3a") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' && n[2] == '0' ) ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"inor4a") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' && n[2] == '0' && n[3] == '0' ) ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"inor5a") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' && n[2] == '0' && n[3] == '0' && n[4] == '0' ) ? '1' : '0';
     return;
   } 
  if ( !strcmp(cellname,"ixor2a") )
   {
     s[0] = ( n[0] == n[1] ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"iand2a") )
   {
     s[0] = ( n[0] == '1' && n[1] == '1' ) ? '1' : '0';
     return;
   }
  if ( !strcmp(cellname,"ior02a") )
   {
     s[0] = ( n[0] == '0' && n[1] == '0' ) ? '0' : '1';
     return;
   } 
  if ( !strcmp(cellname,"imux1b") )
   {
     my_exit ( "imux1b" );
   } 
  if ( !strcmp(cellname,"imux2a") )
   {
     s[0] = ( n[0] == '0' ) ? n[1] : n[2];
     return;
   } 
  if ( !strcmp(cellname,"idec1a") )
   {
     my_exit ( "idec1a" );
     /*
     s[1] = ( (n[1] == '0' && n[0] == '1') || w[0] == '0' ) ? '1' : '0';
     s[0] = ( (n[1] == '1' && n[0] == '1') || w[0] == '0' ) ? '1' : '0';
     */
     return;
   } 
  if ( !strcmp(cellname,"idec2a") )
   {
     my_exit ( "idec2a" );
     /*
     if ( n[0] == '0' )
	s[0] = e[1] = e[2] = e[3] = '1';
      else
      {
	s[0] = ( n[2] == '0' && n[1] == '0' ) ? '0' : '1';
	s[1] = ( n[2] == '0' && n[1] == '1' ) ? '0' : '1';
	s[2] = ( n[2] == '1' && n[1] == '0' ) ? '0' : '1';
	s[3] = ( n[2] == '1' && n[1] == '1' ) ? '0' : '1';
      }
     */
     return;
   } 
  my_exit ( cellname );
}

